reaction = {}

var questionBaseAward = 1000;

reaction.calculateScore = function (game, player) {
	
	var score = 0;
	var multiplier = 1;

	for (var i = 0; i <= game.currentQuestionIndex; i++) {

		var question = game.questions[i];
		var answer = player.answers[i];

		if (answer == null) {
			continue;
		}

		var maxAnswers = question.answers.length;

		var correctAnswers = 0;
		var wrongAnswers = 0;

		answer.options.forEach(function(answerText) {
			if (contains(question.answers, answerText)) {
				correctAnswers++;
			}
			else{
				wrongAnswers++;
			}
		});

		if (wrongAnswers == 0) {
			score += (correctAnswers/maxAnswers).toFixed(2) * questionBaseAward * multiplier;
			multiplier += 1;
		}
		else {
			multiplier = 1;
		}
	}

	return score;
}


reaction.getQuestionFilePath = function() {
	return './questions/completeness.xml';
}

function contains(arr, obj) {
    return (arr.indexOf(obj) != -1);
}

module.exports = reaction;