var quizHost = (function (server) {
    
    var quizHost = {};

    quizHost.init = function(gui) {
        quizHost.gui = gui;
        quizHost.gameId = '';

        quizHost.gui.showSelectGameModeScreen(quizHost.gameModeSelected);
    };

    quizHost.gameModeSelected = function(gameMode) {
        server.createGame(gameMode, quizHost.gameCreated, quizHost.gameEnded);
    };

    quizHost.gameCreated  = function(gameId) {
        quizHost.gameId = gameId;

        quizHost.gui.showStartGameScreen(quizHost.gameId, quizHost.gameStarted);
    };

    quizHost.gameStarted = function() {
        server.prepareNextQuestion(quizHost.gameId, quizHost.prepareQuestion, quizHost.nextQuestion, quizHost.questionEnded);
    };

    quizHost.prepareQuestion = function(time) {
        quizHost.gui.showCountdownScreen(time);
    };

    quizHost.requestNextQuestion = function() {
        //server.nextQuestion(quizHost.gameId, quizHost.prepareQuestion, quizHost.nextQuestion, quizHost.questionEnded);
        server.prepareNextQuestion(quizHost.gameId, quizHost.prepareQuestion, quizHost.nextQuestion, quizHost.questionEnded);
    };

    quizHost.nextQuestion = function(index, text, time, options, gameMode) {
        quizHost.gui.showHostQuestionScreen(index, text, time);
    };

    quizHost.questionEnded = function(scores, answers) {
        quizHost.gui.showHostEndQuestionScreen(scores, answers, quizHost.requestNextQuestion);
    };

    quizHost.gameEnded = function(scores) {
        quizHost.gui.showGameEndScreen(scores);
    };

    return quizHost;
}(quizServer));