var quizPlayer = (function (server) {
    
    var quizPlayer = {};

    quizPlayer.init = function (gui) {
        quizPlayer.gameId = '';
        quizPlayer.questionIndex = 0;
        quizPlayer.playerId = '';
        quizPlayer.playerName = '';

        quizPlayer.gui = gui;

        quizPlayer.gui.showJoinGameScreen(quizPlayer.joinGame);
    };

    quizPlayer.joinGame = function(gameId, playerName) {
        quizPlayer.gameId = gameId;
        quizPlayer.playerName = playerName;
        server.joinGame(quizPlayer.gameId, quizPlayer.playerName, quizPlayer.gameJoined, quizPlayer.prepareQuestion, quizPlayer.nextQuestion, quizPlayer.questionEnded, quizPlayer.gameEnded);
    };

    quizPlayer.gameJoined = function(playerId) {
        quizPlayer.playerId = playerId;
    };

    quizPlayer.prepareQuestion = function(time) {
        quizPlayer.gui.showCountdownScreen(time);
    };

    quizPlayer.nextQuestion = function(index, text, time, options, gameMode) {
        quizPlayer.questionIndex = index;
        quizPlayer.gui.showPlayerQuestionScreen(options, gameMode, quizPlayer.answerSelected);
    };

    quizPlayer.questionEnded = function(scores, answers) {
        quizPlayer.gui.showPlayerEndQuestionScreen(scores, quizPlayer.playerId);
    };

    quizPlayer.gameEnded = function(scores) {
        quizPlayer.gui.showGameEndScreen(scores);
    };

    quizPlayer.answerSelected = function(answers) {
        server.submitAnswer(quizPlayer.gameId, quizPlayer.playerId, quizPlayer.questionIndex, answers);
    };

    return quizPlayer;
}(quizServer));